//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * グラフィックスサンプル スプライト実装
 * @author Junpee
 */

#include <LampBasic.h>
#include <Framework/System/BasicFramework.h>
#include <Graphics2D/Renderer/SpriteRenderer.h>
#include <Graphics2D/Sprite/Sprite.h>
#include <Graphics2D/SpriteState/Graphics2DSpriteStateAll.h>

// Lampのネームスペースを有効にする
using namespace Lamp;

//------------------------------------------------------------------------------
// クラス定義。通常はヘッダファイルに格納する
//------------------------------------------------------------------------------
/**
 * グラフィックスサンプル スプライト
 */
class SampleGraphicsSprite : public BasicFramework{
public:
	/**
	 * コンストラクタ
	 */
	SampleGraphicsSprite(const String& command) :
	  BasicFramework("SampleGraphicsSprite"), command_(command){}

	/**
	 * 初期化
	 * @return 初期化に成功すればtrueを返す
	 */
	virtual bool initialize();

	/**
	 * 後始末
	 */
	virtual void finalize();

	/**
	 * 実行
	 */
	virtual void run();

	/**
	 * レンダリング準備
	 */
	virtual void renderSetup();

	/**
	 * レンダリング
	 */
	virtual void render();

	/**
	 * 情報描画
	 */
	virtual void drawInformation();

private:
	// コマンド文字列
	String command_;
	// 情報文字列
	String informationString_;
	// スプライトレンダラ
	SpriteRenderer* spriteRenderer_;
	// スプライト0
	Sprite* sprite0_;
	// スプライト1
	Sprite* sprite1_;
};
//------------------------------------------------------------------------------
// プログラムエントリポイント
//------------------------------------------------------------------------------
// メイン関数
int WINAPI WinMain(
	HINSTANCE instance, HINSTANCE previousInstance, LPSTR command, int show){
	SampleGraphicsSprite sample(command);
	return sample.execute(instance);
}
//------------------------------------------------------------------------------
// クラス実装
//------------------------------------------------------------------------------
// 初期化
bool SampleGraphicsSprite::initialize(){
backGroundColor_.set(255, 0, 0, 0);
	// レンダラ初期化
	spriteRenderer_ = new SpriteRenderer();

	// スプライト0初期化
	sprite0_ = new Sprite();
	sprite0_->setRectangle(100.f, 100.f, 640.f, 640.f);
	sprite0_->setImageRectangle(0.f, 0.f, 1.f, 1.f);
	sprite0_->loadPicture("testRGBA.tga");
	sprite0_->setFit(Sprite::fitScreenHeight);
	sprite0_->setAlign(Sprite::alignBottomRight);

	// スプライト1初期化
	sprite1_ = new Sprite();
	sprite1_->setRectangle(250.f, 250.f, 64.f, 64.f);
	sprite1_->setImageRectangle(-0.5f, -0.5f, 2.f, 2.f);
	sprite1_->loadPicture("testRGBA.tga");

	return true;
}
//------------------------------------------------------------------------------
// 後始末
void SampleGraphicsSprite::finalize(){
	SafeDelete(sprite1_);
	SafeDelete(sprite0_);
	SafeDelete(spriteRenderer_);
}
//------------------------------------------------------------------------------
// 実行
void SampleGraphicsSprite::run(){
}
//------------------------------------------------------------------------------
// レンダリング準備
void SampleGraphicsSprite::renderSetup(){
	spriteRenderer_->request(sprite0_);
	spriteRenderer_->request(sprite1_);
}
//------------------------------------------------------------------------------
// レンダリング
void SampleGraphicsSprite::render(){
	spriteRenderer_->render();
}
//------------------------------------------------------------------------------
// 情報描画
void SampleGraphicsSprite::drawInformation(){
	BasicFramework::drawInformation();
	drawInformationString(informationString_);
	informationString_ = "";
}
//------------------------------------------------------------------------------
